aboutsummaryrefslogtreecommitdiffhomepage
diff options
context:
space:
mode:
authorGravatar Yun Peng <pcloudy@google.com>2017-08-10 10:51:07 +0200
committerGravatar Marcel Hlopko <hlopko@google.com>2017-08-10 13:48:15 +0200
commit4a2e17f85fc8450aa084b201c5f24b30010c5987 (patch)
tree2969149526e369325b012142464c33eae733fd30
parent1bf94673f1c3308bda0a1272d1ab16736b53a4dd (diff)
Add build_windows_jni.sh back
src/main/native/windows/build_windows_jni.sh is still needed during Windows bootstrap at Building Bazel with Bazel step. Fixed https://github.com/bazelbuild/bazel/issues/3529 Change-Id: I42a1771e8c02a438b866725c98c7f2214620942a PiperOrigin-RevId: 164828380
-rw-r--r--src/main/native/windows/build_windows_jni.sh107
1 files changed, 107 insertions, 0 deletions
diff --git a/src/main/native/windows/build_windows_jni.sh b/src/main/native/windows/build_windows_jni.sh
new file mode 100644
index 0000000000..5d39b8f436
--- /dev/null
+++ b/src/main/native/windows/build_windows_jni.sh
@@ -0,0 +1,107 @@
+#!/bin/bash -eu
+
+# Copyright 2016 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# It's not a good idea to link an MSYS dynamic library into a native Windows
+# JVM, so we need to build it with Visual Studio. However, Bazel doesn't
+# support multiple compilers in the same build yet, so we need to hack around
+# this limitation using a genrule.
+
+DLL="$1"
+shift 1
+
+function fail() {
+ echo >&2 "ERROR: $@"
+ exit 1
+}
+
+# Ensure the PATH is set up correctly.
+if ! which which >&/dev/null ; then
+ PATH="/bin:/usr/bin:$PATH"
+ which which >&/dev/null \
+ || fail "System PATH is not set up correctly, cannot run GNU bintools"
+fi
+
+# Create a temp directory. It will used for the batch file we generate soon and
+# as the temp directory for CL.EXE .
+VSTEMP=$(mktemp -d)
+trap "rm -fr \"$VSTEMP\"" EXIT
+
+# Find Visual Studio. We don't have any regular environment variables available
+# so this is the best we can do.
+if [ -z "${BAZEL_VS+set}" ]; then
+ VSVERSION="$(ls "C:/Program Files (x86)" \
+ | grep -E "Microsoft Visual Studio [0-9]+" \
+ | sort --version-sort \
+ | tail -n 1)"
+ [[ -n "$VSVERSION" ]] || fail "Visual Studio not found"
+ BAZEL_VS="C:/Program Files (x86)/$VSVERSION"
+fi
+VSVARS="${BAZEL_VS}/VC/VCVARSALL.BAT"
+
+# Check if Visual Studio 2017 is installed. Look for it at the default
+# locations.
+if [ ! -f "${VSVARS}" ]; then
+ VSVARS="C:/Program Files (x86)/Microsoft Visual Studio/2017/"
+ VSEDITION="BuildTools"
+ if [ -d "${VSVARS}Enterprise" ]; then
+ VSEDITION="Enterprise"
+ elif [ -d "${VSVARS}Professional" ]; then
+ VSEDITION="Professional"
+ elif [ -d "${VSVARS}Community" ]; then
+ VSEDITION="Community"
+ fi
+ VSVARS+="$VSEDITION/VC/Auxiliary/Build/VCVARSALL.BAT"
+fi
+
+if [ ! -f "${VSVARS}" ]; then
+ fail "VCVARSALL.bat not found, check your Visual Studio installation"
+fi
+
+# Find Java. $(JAVA) in the BUILD file points to external/local_jdk/..., which
+# is not very useful for anything not MSYS-based.
+JAVA=$(ls "C:/Program Files/java" | grep -E "^jdk" | sort | tail -n 1)
+[[ -n "$JAVA" ]] || fail "JDK not found"
+JAVAINCLUDES="C:/Program Files/java/$JAVA/include"
+
+# Convert all compilation units to Windows paths.
+WINDOWS_SOURCES=()
+for i in $*; do
+ if [[ "$i" =~ ^.*\.cc$ ]]; then
+ WINDOWS_SOURCES+=("\"$(cygpath -a -w $i)\"")
+ fi
+done
+
+# Copy jni headers to src/main/native folder
+# Mimic genrule //src/main/native:copy_link_jni_md_header and //src/main/native:copy_link_jni_header
+JNI_HEADERS_DIR="${VSTEMP}/src/main/native"
+mkdir -p "$JNI_HEADERS_DIR"
+cp -f "$JAVAINCLUDES/jni.h" "$JNI_HEADERS_DIR/"
+cp -f "$JAVAINCLUDES/win32/jni_md.h" "$JNI_HEADERS_DIR/"
+
+# CL.EXE needs a bunch of environment variables whose official location is a
+# batch file. We can't make that have an effect on a bash instance, so
+# generate a batch file that invokes it.
+cat > "${VSTEMP}/windows_jni.bat" <<EOF
+@echo OFF
+@call "${VSVARS}" amd64
+@cd $(cygpath -a -w "${PWD}")
+@set TMP=$(cygpath -a -w "${VSTEMP}")
+@CL /O2 /EHsc /LD /Fe:"$(cygpath -a -w ${DLL})" /I "${VSTEMP}" /I . ${WINDOWS_SOURCES[*]}
+EOF
+
+# Invoke the file and hopefully generate the .DLL .
+chmod +x "${VSTEMP}/windows_jni.bat"
+exec "${VSTEMP}/windows_jni.bat"